

package porterNbo;
require Exporter;
@porterNbo::ISA = qw(Exporter);
@porterNbo::EXPORT = qw();
@porterNbo::EXPORT_OK = qw(stem_nbo);


sub stem_nbo {
	my $term = shift;
#print "Orginal: $term <br>";


#Step 1:
#
#     Search for the longest among the following suffixes in
#     R1, and perform the action indicated.
#     
#     (a) a   e   ede   ande   ende   ane   ene   hetene   en
#         heten   ar   er   heter   as   es   edes   endes   enes
#         hetenes   ens   hetens   ers   ets   et   het   ast
#
#         -> delete
@R1_suffix = ("a","e","en","ar","er","as","es","et","ers","ede","ane","ene","ets","het","ast","ens","ande","ende","edes","enes","endes","heter","heten","hetene","hetens","hetenes");   

reverse(@R1_suffix);
$funet = 'FALSE';
foreach $suffix (@R1_suffix) {  
	#hvis vi ikke alerede har funnet det vi leter etter
	if ($funet ne 'TRUE') {
		if ($term =~ /$suffix$/i) {
			$term =~ s/$suffix$//i;
			#setter $funet slik at vi ikke gjr noe mere
			$funet = 'TRUE';
		}
	}
}  
#     (b) s      
#Define a valid s-ending as one of
#
#     b   c   d   f   g   h   j   k   l   m   n   o   p   r
#     t   v   y   z
#
#         -> delete if preceded by a valid s-ending  
@s_endinger = ("b","c","d","f","g","h","j","k","l","m","n","o","p","r","t","v","y","z");

#sjekker om ordet begynner p s
$funet = 'FALSE';
if ($term =~ /s$/i) {
	foreach $s_mulige (@s_endinger) { 
		if ($funet ne 'TRUE') {
			if (($term =~ /$s_mulige[s]$/i)) {
				$term =~ s/s$//i;
			#setter $funet slik at vi ikke gjr noe mere
				$funet = 'TRUE';
			}
		}
	}
}
#     (c) erte   ert
#
#         -> replace with ert
#ToDo: her erstater jeg det bare hvis det er p slutten av et ord, hva med mitt inn, skal det erstetes da ogs?
if ($term =~ /erte$/i) {
	$term =~ s/erte$/ert/i;
}
#Step 2:
#
#     If the word ends dt or vt in R1, delete the t.
#     (For example, meldt -> meld, operativt -> operativ)
if ($term =~ /dt$/i) {
	$term =~ s/dt$/d/i;
}
if ($term =~ /vt$/i) {
	$term =~ s/vt$/v/i;
}
#Step 3:
#
#     Search for the longest among the following suffixes in
#     R1, and if found, delete.
#     
#     leg   eleg   ig   eig   lig   elig   els   ing   lov   elov
#     slov   hetslov
@R1_suffix = ("leg","eleg","ig","eig","lig","elig","els","ing","lov","elov","slov","hetslov");   

reverse(@R1_suffix);
$funet = 'FALSE';
foreach $suffix (@R1_suffix) {  
	#hvis vi ikke alerede har funnet det vi leter etter
	if ($funet ne 'TRUE') {
		if ($term =~ /$suffix$/i) {
			$term =~ s/$suffix$//i;
			#setter $funet slik at vi ikke gjr noe mere
			$funet = 'TRUE';
		}
	}
}  

#print "Forslag: $term";
	return $term;
}